from __future__ import unicode_literals

from django.apps import apps

from evote.celery import app
from django_fsm import can_proceed


def get_electoral_process(pk):
    ElectoralProcess = apps.get_model('evoteprocesses.ElectoralProcess')  # noqa
    return ElectoralProcess.objects.get(pk=pk)


@app.task(ignore_result=True)
def publish_electoral_process(electoral_process_id):
    """ """
    electoral_process = get_electoral_process(electoral_process_id)
    if can_proceed(electoral_process.publish):
        electoral_process.publish()
        electoral_process.save()
    return electoral_process


@app.task(ignore_result=True)
def close_electoral_process(electoral_process_id):
    """ """
    electoral_process = get_electoral_process(electoral_process_id)
    if can_proceed(electoral_process.close):
        electoral_process.close()
        electoral_process.save()
    return electoral_process


@app.task(ignore_result=True)
def archive_electoral_process(electoral_process_id):
    """ """
    electoral_process = get_electoral_process(electoral_process_id)
    if can_proceed(electoral_process.archive):
        electoral_process.archive()
        electoral_process.save()
    return electoral_process
